`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: SERVO MAGAZINE
// Engineer: FRED EADY
// 
// Create Date:    10:52:24 06/16/2008 
// Design Name: 
// Module Name:    rcservo 
// Project Name: 
// Target Devices: COOLRUNNER-II CPLD
// Tool versions:  ISE WEBPACK 10
// Description: SINGLE SERVO BUTTON CONTROLLED ROTATION
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module rcservo(
    input clk_1mhz,
    output reg pwm_out,
    input  [1:0] btn_input
    );
	
	parameter	minpulsewidth = 1000;
	
	reg	[13:0]	window_32ms;	
	reg	[9:0]	servo_vector;	
	
//************************************************************
//* GENERATE 32mS SERVO CONTROL PULSE WINDOW
//************************************************************
always @(posedge clk_1mhz)
	window_32ms <= window_32ms + 1;
//************************************************************
//* GENERATE SERVO CONTROL PULSES
//************************************************************
always @(posedge clk_1mhz)
	  pwm_out <= (window_32ms < (servo_vector + minpulsewidth));
//************************************************************
//* DETERMINE SERVO ROTOR DIRECTION
//************************************************************
always @(posedge clk_1mhz)
	if(window_32ms == 0)
	  case(btn_input)
	  2'b01:	servo_vector <= servo_vector + 1;
	  2'b10:	servo_vector <= servo_vector - 1;
	  2'b11:	servo_vector <= 500;
	  endcase
	 
endmodule
