`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: SERVO MAGAZINE
// Engineer: FRED EADY
// 
// Create Date:    10:52:24 06/16/2008 
// Design Name: 
// Module Name:    rcservo 
// Project Name: 
// Target Devices: COOLRUNNER-II CPLD
// Tool versions: ISE WEBPACK 10
// Description: TWO SERVOS AUTOMATIC OPPOSITE ROTATION
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module rcservo(
    input clk_1mhz,
    output  reg pwm_out1,
	 output  reg pwm_out2
    );
	
	parameter	minpulsewidth = 1000;

	reg	[14:0]	window_32ms;	
	reg	[9:0]		servo_vector1;	
	reg	[9:0]		servo_vector2;	
	reg	servo_direction;
	
//************************************************************
//* GENERATE SERVO CONTROL PULSE WINDOW
//************************************************************
always @(posedge clk_1mhz)
	window_32ms <= window_32ms + 1;
//************************************************************
//* GENERATE SERVO CONTROL PULSES
//************************************************************
always @(posedge clk_1mhz)
begin
	  pwm_out1 <= (window_32ms < (servo_vector1 + minpulsewidth));
	  pwm_out2 <= (window_32ms < (servo_vector2 + minpulsewidth));
end
//************************************************************
//* DETERMINE SERVO ROTOR DIRECTION
//************************************************************
always @(posedge clk_1mhz)
 begin
	if(window_32ms == 0)
	 begin
		if(servo_vector1 == 0 || servo_vector1 == 1000)
		 servo_direction = ~servo_direction;
		 
		if(servo_direction)
		begin
			servo_vector1 <= servo_vector1 + 1;
			servo_vector2 <= servo_vector2 - 1;
		end
		else
		begin
			servo_vector1 <= servo_vector1 - 1;
			servo_vector2 <= servo_vector2 + 1;
		end
	 end
 end

endmodule
