`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: SERVO MAGAZINE
// Engineer: FRED EADY
// 
// Create Date:    10:52:24 06/16/2008 
// Design Name: 
// Module Name:    rcservo 
// Project Name: 
// Target Devices: COOLRUNNER-II CPLD
// Tool versions: ISE WEBPACK 10
// Description: SINGLE SERVO ROTATION
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module rcservo(
    input clk_1mhz,
    output reg pwm_out
    );
	
	parameter	minpulsewidth = 1000;
	//parameter	servo_vector	= 0;

	reg	[13:0]	window_16ms;	
	reg	[9:0]	servo_vector;	
	reg	servo_direction;
	

always @(posedge clk_1mhz)
	window_16ms <= window_16ms + 1;

always @(posedge clk_1mhz)
	  pwm_out <= (window_16ms < (servo_vector + minpulsewidth));

always @(posedge clk_1mhz)
 begin
	if(window_16ms == 0)
	 begin
		if(servo_vector == 0 || servo_vector == 1000)
		 servo_direction = ~servo_direction;
		 
		if(servo_direction)
			servo_vector <= servo_vector + 1;
		else
			servo_vector <= servo_vector - 1;
	 end
 end

endmodule
